#ifndef CONSTS_H_BUBWINY
#define CONSTS_H_BUBWINY

#define CONSOLE_SIZE          100

#define GAMESTEP_T            2

#define MUL_MOVE              16384
#define MUL_HALF              8192
#define SHIFT_MOVE            14

#define VGA_MIN               0
#define VGA_MAX_X             640
#define VGA_MAX_Y             480
#define PLAYFIELD_MIN_X       0
#define PLAYFIELD_MAX_X       640
#define PLAYFIELD_EMIN_Y      0
#define PLAYFIELD_EMAX_Y      480
#define PLAYFIELD_MIN_Y       40
#define PLAYFIELD_MAX_Y       440

#define PLAYFIELD_TOP         40

#define MAX_FALLSPEED         6881
#define SPEED_BUBBLE          9830
#define JUMP_STRENGTH         9500
#define MOVE_ACCEL            24      // zrychleni doleva|doprava

#define MOVE10                196
#define MOVE25                491
#define MOVE50                983
#define MOVE100               1966
#define MOVE150               2949
#define MOVE200               3932
#define MOVE250               4915
#define MOVE300               5898
#define MOVE350               6881
#define MOVE400               7864
#define MOVE450               8847
#define MOVE500               9830
#define MOVE600               11796
#define MOVE650               12779
#define MOVE700               13762
#define MOVE750               14745
#define MOVE800               15728
#define MOVE900               17694
#define MOVE1000              19660

#define FUQSTRENGTH_STATIC    9830
#define FUQSTRENGTH_DYNAMIC   19660

#define BONUS_MOVEX1          3936
#define BONUS_MOVEX2          7872
#define BONUS_MOVEY           6880     
#define BONUS_BLINKPERIOD     500
#define BONUS_BLINKLENGTH     250
#define BONUS_WARN            6000
#define BONUS_WARNING         7500
#define BONUS_LIFE            8000

#define SP_COL_L              1
#define SP_COL_R              2
#define SP_COL_D              4
#define SP_COL_U              8

#define MAX_TINTS             5
#define TNT_SIZE555           32768
#define TNT_SIZE565           65536
#define TNT_GLASS             0
#define TNT_3G                1
#define TNT_5G                2
#define TNT_3B                3
#define TNT_5B                4

#define MAP_TOP               2
#define MAP_BOTTOM            22
#define MAP_SIZE              768
#define MAP_XSIZE             32
#define MAP_YSIZE             24
#define MAP_CELX              20
#define MAP_CELY              20
#define MAP_ERROR             255

#define WNDMAP_SIZE           640
#define WNDMAP_YSIZE          20

#define MSG_X                 320
#define MSG_Y                 240
#define MSG_DURATION          1500

#define MAX_MONSTERS          25
#define MAX_BALS              100
#define MAX_FTABLES           3
#define MAX_BONUSES           40
#define MAX_QBUBS             15 
#define MAX_SBUBS             40
#define MAX_SYMBUBS           12
#define MAX_TPORTS            12
#define MAX_FTPORTS           3
#define MAX_UFOS              20
#define MAX_TINT              16
#define MAX_BUBLIFUX          4

#define MAX_TEXTS             8

#define EGG_SHOT              357
#define EGG_DELAY             4998

#define ID_PLAYER1            1
#define ID_PLAYER2            2
#define ID_ZOMB               4
#define ID_NEBULUS            5
#define ID_BUTTRED            6
#define ID_BUTTBLUE           7
#define ID_KACHNA             8
#define ID_BUTTYELLOW         9
#define ID_DRAGONRED          10
#define ID_DRAGINYELLOW       11
#define ID_BUNNY              12
#define ID_BUBBLE             30
#define ID_SBUBBLE            31
#define ID_MURRAYG            32
#define ID_MURRAYB            33
#define ID_BUNMEAT            34
#define ID_BUNPANT            35
#define ID_SOLIDBUBBLEG       36
#define ID_SOLIDBUBBLEB       37
#define ID_EGG                38
#define ID_FIREBALL           39
#define ID_RUBY               48
#define ID_SOLIDBUBBLEW       64
#define ID_BFUK               65
#define ID_FTPORT             66
#define ID_TPORT              67

#define SPMA_LEFT             1       // 'moveleft available' flag
#define SPMA_RIGHT            2       // 'moveright available' flag
#define SPMA_JUMP             4       // 'jump available' flag
#define SPMA_FIRE             8       // 'fire available' flag

#define CHAIN_STAND	         0       // framechain of a standing sprite
#define CHAIN_BUBLIFUQ        0       // ...bublifuk
#define CHAIN_WALK	         1       // ...walking sprite
#define CHAIN_BLOW            1       // ...blowing bubble
#define CHAIN_MELT            1       // ...melting UFO
#define CHAIN_RELEASE         2       // ...releasing bubble
#define CHAIN_JUMP	         2       // ...jumping sprite
#define CHAIN_FALL	         3       // ...falling sprite
#define CHAIN_FIRE	         4       // ...firing sprite
#define CHAIN_BUBBLE          5	     // ...creature inside bubble
#define CHAIN_SCRAPE 	      6       // ...creature scratching in a bubble 
#define CHAIN_DYING           7       // ...dying player
#define ACTION_MAX	         7	     // maximal framechain number

#define DFT_GRAVITY           32
#define DFT_TIMELIMIT         90000

#define IN_BOUNDS             1
#define OUT_OF_BOUNDS         0

#define SCL_LEFT              1
#define SCL_RIGHT             2
#define SCL_JUMP              4
#define SCL_FIRE              8

#define BLOWING               4       // bublina stav: praska
#define DEAD                  8       // player stav: mrkev
#define INVISIBLE             2       //            : neviditelny
#define RESURRECTED           16      //            : oziven (spis nezranitelny)
#define INBUBBLE              32      //            : v bubline
#define IMMORTAL              64      //            : nesmrtelny (jen cheatem?)
#define WANNALEAVE            128     //            : chce skrabat na bublinu
#define INACTIVE              40      //            : je pasivni (32+8)
#define RESISTANT             120     //            : je odolny vuci odzivotneni
#define UNCHASEABLE           43      //            : nemuzou ho "videt" potvurky (32+8+2+1)
#define NOTTAKEN              1       //            : nebyl doposud aktivovan
#define UNCONTROLLED          17      //            : nebyl doposud aktivovan(+nesm)
#define NOCREDIT              9       //            : nevlastni kredit
#define NOSCORING             41      //            : nema narok ziskavat bonusy apod.
#define UFO_RESISTANT         121     //            : odolna vuci UFO
#define BUBBLE_RESISTANT      41      //            : odolnost vuci chyceni do bubliny

#define DEF_LIVES              8
#define MAX_LIVES             20

#define DROP_SIZE             4
#define MAXDROP               30
#define MAX_DROP_COLOR        6
#define DROP_GREEN            0
#define DROP_BLUE             1
#define DROP_RED              2
#define DROP_YELLOW           3
#define DROP_WHITE            4
#define DROP_BLACK            5
#define DROP_FIRE             6

#define BUB_LIFETIME          15000    // 30 sec
#define BUB_SCRAPEEFFECT      3000     // o kolik scratch sejme bublinu
#define BUB_SCRAPELENGTH      250      // delka samplu
#define BUB_LASTSCRAPE        3150     // kdy muze nastat posledni scratch
#define BUB_BLOWCOME1         1250     // monster scratch 1
#define BUB_BLOWCOME2         675      // monster scratch 2
#define BUB_DOMINATED         150      // delka domina
#define BUB_BLOWTIME          100      // zacatek praskani      
#define BUB_BLOWSTART         64       // bit indikujici praskajici bublinu
#define BUB_BLOWEND           128      // bit indikujici prasklou bublinu
#define BUB_XSIZE             40
#define BUB_YSIZE             40
#define BUB_START             14950    // zacatek ucinnosti bubliny na potvurky

#define REASON_DEFAULT        0
#define REASON_EXIT           1
#define REASON_NEXTLEVEL      2
#define REASON_NOTOPPERS      3
#define REASON_LEVELNOTFOUND  4
#define REASON_THEEND         5

#define SF_PAUSED             1
#define SF_BOSS               2
#define SF_HELP               4
#define SF_STATS              8

#define PLAYERBONUS_HITTOLX   4
#define PLAYERBONUS_HITTOLY   4
#define PLAYERMONSTER_HITTOLX 8
#define PLAYERMONSTER_HITTOLY 8
#define BUBBLEMONSTER_HITTOLX 10
#define BUBBLEMONSTER_HITTOLY 10
#define UFOPLAYER_HITTOLX     4
#define UFOPLAYER_HITTOLY     4

#define TOPPERS_SCROLLSPEED   10

#endif


