#ifndef GRAPHDD_H_ERIADOR
#define GRAPHDD_H_ERIADOR

#include "dxconsts.h"
#include <ddraw.h>
#include <windows.h>
#include "consts.h"
#include "types.h"

#define TO555(x) (((x)&bMask)+(((x)&0xFFC0)>>1))
#define TO565(x) (((x)&bMask)+(((x)&0x3E0)<<1)+(((x)&0x7c00)<<1))
#define RGB2555(r,g,b) ((b>>3)+((g>>3)<<5)+((r>>3)<<10))
#define RGB2565(r,g,b) ((b>>3)+((g>>2)<<5)+((r>>3)<<11))

#define COLOR_KEY565  0xF81F
#define COLOR_KEY555  0x7C1F

extern LPDIRECTDRAW lpDD;
extern LPDIRECTDRAW4 lpDD4;
extern DDCAPS ddc1;

extern Surface frontbuffer;
extern Surface backbuffer;
extern Surface background;

extern bool usedmap1[10][12];
extern bool usedmap2[10][12];
extern bool (*usedmap)[10][12];
extern int clusmapx,clusmapy;
#define SET_USEDMAP(x,y) (*usedmap)[(x)>>6][(y)/40] = true;
//#define SET_USEDMAP(x,y) usedmap[0][0] = true;
#define CLEAR_USEDMAP \
   for(clusmapx=0; clusmapx < 10; clusmapx++) \
      for(clusmapy=0; clusmapy < 12; clusmapy++) \
         (*usedmap)[clusmapx][clusmapy] = false;
#define FILL_USEDMAP_PLAYFIELD(map2fill) \
   for(clusmapx=0; clusmapx < 10; clusmapx++) \
      for(clusmapy=1; clusmapy < 11; clusmapy++) \
         (map2fill)[clusmapx][clusmapy] = true;
#define FLIP_USEDMAP usedmap = (usedmap == &usedmap1)? &usedmap2:&usedmap1;

extern WORD colorKey;
extern WORD rMask;
extern WORD gMask;
extern WORD bMask;
extern BYTE gBits;

extern DDPIXELFORMAT ddpf;
extern HRESULT ddResult;
extern bool ddRestored;
extern DWORD prefferedCAPS;

extern RECT rFullScreen;

void initDD(HWND hWnd, DWORD width, DWORD height, DWORD bitdepth, DWORD refreshrate);
void putcel(int x, int y, Surface dest, RECT &r, Surface src, DWORD dwFlags = DDBLTFAST_SRCCOLORKEY);
void putcelBlt(int x, int y, Surface dest, RECT &r, Surface src, 
               DWORD dwFlags = 0, DDBLTFX *lpBltFX = NULL);
void puttint(int x, int y, Surface dest, RECT &r, Surface src, TintTable tnt);
void puttintm(int x, int y, Surface dest, RECT &r, TintMask mask, TintTable tnt);
void puttinted(int x, int y, Surface dest, RECT &r, Surface src,
               TintTable tnt);
void puttinted50(DWORD x,DWORD y,Surface dest,RECT &r,Surface src,
                 int color);
void puttransparent(int x, int y, Surface dest, RECT &r, Surface src);
void puttransparentcached(int srcx, int srcy, Surface src,
                          int destx, int desty,Surface dest, 
                          RECT &r,Surface mask);
void tint_redalert(Surface src,RECT &r);
void tint50(Surface src,WORD color);
void puttint50(DWORD srcx,DWORD srcy,Surface src,
          RECT &r, TintMask mask, WORD color);
void puttint50cached(DWORD srcx,DWORD srcy,Surface src,
                   DWORD destx,DWORD desty,Surface dest,
                   RECT &r, TintMask mask, WORD color);
void putdark50(int x, int y, Surface dest, RECT &r, Surface src);
void putdark25(int x, int y, Surface dest, RECT &r, Surface src);
Surface getcel(Surface src, RECT &r);
void clear(Surface surf,WORD fillColor,RECT *rect);
void setColorKey(Surface surf, WORD cKey);
void flip(DWORD dwFlags);
void lock(Surface surf, RECT *lpR, LPDDSURFACEDESC2 lpDDSD, DWORD dwFlags = 0);
void screenshot(Surface pdds, const char *name);
void doneDD();

#endif
