#ifndef R16_H_ERIADOR
#define R16_H_ERIADOR

#include <wtypes.h>
#include "types.h"

#define R16_RESERVED_CNT 24

extern const char R16ID[4];
extern const char R16DAT[4];

struct R16Header {
   char szId[4];
   DWORD dwWidth;
   DWORD dwHeight;
   DWORD dwCelWidth;
   DWORD dwCelHeight;
   BYTE  byCelRow;
   BYTE  byGreenBits;
   BYTE  byType;
   BYTE  byFontFirst;
   BYTE  reserved[R16_RESERVED_CNT];
   char szStartData[4];
};

void saveR16(Surface surf, TCHAR *lp_szName, BYTE gbits = 6, 
             DWORD celx = 0, DWORD cely = 0, BYTE celrow = 0, 
             BYTE fontfirst = 32);
void reLoadR16(Surface surf, char *name, char *fakename = NULL, 
               R16Header *hdr = NULL);;
Surface loadR16(char *name, char *fakename = NULL, R16Header *hdr = NULL,
                DWORD dwFlags = DDSCAPS_OFFSCREENPLAIN);
WORD * loadR16WORD(char *name, char *fakename, R16Header *hdr);
void saveR16WORD(WORD *r16, char *name, R16Header *hdr);
  
#endif