#ifndef _ARRAY2_H
#define _ARRAY2_H

extern int arr_i;

#define DECLARE_ARRAY_EXTERN(type,name,control,size) \
   extern type name[size];                           \
   extern ArrayControl control;


#define DECLARE_ARRAY(type,name,control,size) \
   type         name[size];                   \
   ArrayControl control = { 0, size };


#define ARRAY_ADD(name,control,what) \
   name[control.count++] = what;


#define ARRAY_REMOVE_AT(name,control,index)           \
   if (index < control.count)                         \
   {                                                  \
     name[index] = name[--control.count];             \
     name[control.count] = NULL;                      \
   }


#define ARRAY_REMOVE_AT_AND_DELETE(name,control,index)\
   if (index < control.count)                         \
   {                                                  \
     delete(name[index]);    	                      \
     name[index] = name[--control.count];             \
     name[control.count] = NULL;                      \
   }


#define ARRAY_REMOVE(name,control,member)              \
   for (arr_i = 0; arr_i < control.count; arr_i++)     \
   {      			                       \
     if (name[arr_i] == member)                        \
     {                                                 \
       name[arr_i] = name[--control.count];            \
       name[control.count] = NULL;                     \
     }                                                 \
   }


//zda se, ze se vubec nikde nepouziva... =)
#define ARRAY_REMOVE_AND_DELETE(name,control,member)   \
   for (arr_i = 0; arr_i < control.count; arr_i++)     \
   {      			                       \
     if (name[arr_i] == member)                        \
     {                                                 \
       delete(name[arr_i]);    	                      \
       name[arr_i] = name[--control.count];            \
       name[control.count] = NULL;                     \
     }                                                 \
   }


//remove_all VZDY soucasne dealokuje
#define ARRAY_REMOVE_ALL(name,control)                 \
   for (arr_i = 0; arr_i < control.count; arr_i++)     \
   {      			                       \
     delete(name[arr_i]);                              \
     name[arr_i] = NULL;                               \
   }                                                   \
   control.count = 0;


#define ARRAY_FULL(control) \
   (control.count == control.size)


#define ARRAY_AT(name,index) \
   name[index]


struct ArrayControl {
  int count;
  int size;
};

#endif