#ifndef GAME_H_BUBWINY
#define GAME_H_BUBWINY

#include "consts.h"
#include "array2.h"
#include "types.h"
#include "utils.h"
#include "message.h"
#include "property.h"
#include "sprites.h"
#include "rglass.h"
#include "gamestage.h"
#include "drops.h"

//  #define FILEDEBUG

#define I i=0;
#define J j=0;

DECLARE_ARRAY_EXTERN(Creature*,monsters,monsters_ctrl,MAX_MONSTERS+2)
DECLARE_ARRAY_EXTERN(Bonus*,bonuses,bonuses_ctrl,MAX_BONUSES);
DECLARE_ARRAY_EXTERN(Bubble*,qbubbles,qbubbles_ctrl,MAX_QBUBS);
DECLARE_ARRAY_EXTERN(Bubble*,sbubbles,sbubbles_ctrl,MAX_SBUBS);
DECLARE_ARRAY_EXTERN(SymbolBubble*,symbubs,symbubs_ctrl,MAX_SYMBUBS);
DECLARE_ARRAY_EXTERN(Teleport*,teleports,teleports_ctrl,MAX_TPORTS);
DECLARE_ARRAY_EXTERN(Teleport*,ftports,ftports_ctrl,MAX_FTPORTS);

extern DropList      *drops;
extern Map           map;
extern WindMap       windmap;
extern Player        *player1, *player2;
extern RGlass        **glasses;
extern Surface       m_background;
extern Surface       tiles;
extern Surface       sym_bubgfx;
extern Surface       timer10_gfx;
extern Surface       statbar_gfx;
extern Message       message;
extern char          levelname[20], *nextlvls;
extern bool          exitgame;
extern short         monstercnt;
extern BYTE          startlives;
extern DWORD         time;
extern bool          enteredpass;
extern bool          s_drops;
extern bool          s_darken;
extern bool          s_catchy;
extern BYTE          s_gamma;
extern BYTE          lives_chg;
extern int           gravitation;
extern int           mirror;
extern Timer         frozen;
extern WORD          timesecond;
extern BYTE          timercolor;
extern Properties    properties;
extern char          *backname;
extern char          filnam[20];
extern int           picnum;
extern int           vanish;

extern DWORD         timelimit;
extern int           timer;
extern DWORD         timecurrent;
extern DWORD         timeunit;
extern int           time_chg;
   
extern char          s_name[4][32];
extern BYTE          s_key[4][4];
extern char          s_password[32];
extern BYTE          s_vol;
extern BYTE          s_sfx;
extern BYTE          s_cd;
extern bool          s_solidbubbles;
extern bool          s_usecd;
extern bool          s_cdorder;
extern bool          s_turtle;
extern bool          s_test;
extern bool          s_testsymbol;
extern bool          s_testholy;
extern bool          s_holy;
extern bool          s_report;
extern bool          s_cdcheck;
extern bool          s_changepass;
extern bool          s_digi;
extern bool          s_sound;
extern bool          s_reverse_stereo;
extern char          s_leveldesc[MAX_TEXTS][30];
extern bool          enteredpass;

#ifdef FILEDEBUG
#include <stdio.h>
extern FILE *fw;
#endif

void gfx_load();

class Game : public GameStage {

public:
   int magictime;
   int magiccount;
   int panpos;
   int last_alert;
   int to_fuq;           //kolik symbolu ma vyplivnout

   //settings a 'systemove' promenne
   bool exitsys;

   Game();
   virtual ~Game ();

   virtual void load();
   virtual void start();
   virtual void update();
   virtual void stop();
   virtual void unload();
   virtual void restore();

   void startLevel();
   void StartGame();
   int LoadLevel();
   void DoneLevel();
   void DoneGame();
	void PrepareBackground();

	Surface background_redalert;
	Surface background_normal;
};

#endif