/*
 *--------------------------------------------------------------------
 *
 * property
 *
 * nacitani a udrzovani properties pro jednotlive herni objekty
 *
 * verze   0.0.2 - 14.06.1999
 * autori  Gunny, Vojvo
 *
 *--------------------------------------------------------------------
 */

#ifndef PROPERTY_H_42
#define PROPERTY_H_42

#define MAX_ID  68
#define MAX_LINE 128

#include "framesv.h"
#include "types.h"
#include "r16.h"

class Property
{
public:
   BYTE id;
   int xsize, ysize, rsize; // rozmery celu a jejich pocet v radku
   int xoff, yoff;          // ???
   int stablel, stabler;    // body stability
   int speed;               // ???
   int tint,tint2;          // index na doporuceny tint (hlavne pro ovoce)
   int value1;              // bodova hodnota - ovoce, potwory
   int value2;              // bodova hodnota - ovoce, potwory
   int hitx,hity;           // meze pro detekce kolizi
   int mask;                // priznak, jestli se ma generovat maska grafiky
   Surface surf;            // surface s grafikou
   Surface bubsurf;         // surface s grafikou v bubline;
   TintMask tintmask;       // maska spritu pro tint
   WORD tintcolor;          // barva tintu pro tint50
   WORD tintcolor2;          // barva tintu pro tint50
   int totxsize,totysize;   // celkova velikost surface
   R16Header *r16h;         // hlavicka surface
   Frames frames;           // framechainy
   DWORD fTgs;              // pocet ms na jeden frame animace
   
   Property();
   
   ~Property() 
   {
      if (tintmask != NULL)
      {
         delete [] tintmask;
         tintmask = NULL;
      }
   }
};

class Properties
{
public:
   Property * member[MAX_ID];

   Properties();
   
   int load(char *filename);

   ~Properties();
   
};

#endif