/*--------------------------------------------------------------------
 *
 * TheEnd
 *
 * Usek hry - dohrani cele hry
 *
 * verze   0.99.1 - 22.11.1999
 * autori  Vojvo
 *
 *--------------------------------------------------------------------
 * zmeny
 * 0.99.1 - demoverze
 *        - pridan zvuk pri prepinani
 *        - advert vyuziva fakeopen
 * 0.11.2 - prvni verze
 */

#include "dxconsts.h"
#include <stdio.h>
#include "exceptions.h"
#include "keyboard.h"
#include "graphdd.h"
#include "surfaceManager.h"
#include "fakedir.h"
#include "wsound.h"
#include "application.h"
#include "theend.h"

//-------------------------------------------------------------------------
// inicializuje veci potrebne pro spousteni
//-------------------------------------------------------------------------
void TheEnd::load()
{
}

//-------------------------------------------------------------------------
// zahajuje cinnost
//-------------------------------------------------------------------------
void TheEnd::start()
{
#ifdef CLASSIC_DEBUG
   OutputDebugString("TheEnd::start()\n");
#endif
   FILE *ftest;
   char fname[20];
   
   shotnum = 1;
   nextnotfound = false;
   sprintf(fname,"data\\advert%d.r16",shotnum);
   ftest = fakeopen("data\\pictures.dir",fname,"rb");
   if (ftest == NULL)
   {
      nextnotfound = true;
   }
   else
   {
      fclose(ftest);
      surfaceManager->remove(background,true);
      background = surfaceManager->load(fname+5,"data\\pictures.dir",true);
   }
   kbd.lastScanReset();
   kbd.lastASCIIReset();
   kbd.filter_lastscan = false;
   sound_device->Play(24);
#ifdef CLASSIC_DEBUG
   OutputDebugString("TheEnd::start()\n");
#endif
}

//-------------------------------------------------------------------------
// pravidelna cinnost pri kazdem pruchodu hlavni smyckou programu
//-------------------------------------------------------------------------
void TheEnd::update()
{
   BYTE k;

   if (nextnotfound)
   {
      app->stateChange();
      return;
   }

   // klavesnice
   kbd.getState();

   if ((k=kbd.LastScan()) != 0)
   {
#ifdef CLASSIC_DEBUG
   OutputDebugString("TheEnd:LastScan\n");
#endif
      kbd.clearKey(k);
  	   kbd.lastScanReset();
      FILE *ftest;
      char fname[20];
      shotnum++;
      sprintf(fname,"data\\advert%d.r16",shotnum);
      ftest = fakeopen("data\\pictures.dir",fname,"rb");
      if (ftest == NULL)
      {
         nextnotfound = true;
      }
      else
      {
         fclose(ftest);
         surfaceManager->remove(background);
         background = surfaceManager->load(fname+5,"data\\pictures.dir");
         sound_device->Play(24);
      }
   }
   putcel(0,0,backbuffer,rFullScreen,background,DDBLTFAST_NOCOLORKEY);
   flip(0);
}

//-------------------------------------------------------------------------
// obnoveni po surface lost
//-------------------------------------------------------------------------
void TheEnd::restore()
{
   FILE *ftest;
   char fname[20];
   sprintf(fname,"data\\advert%d.r16",shotnum);
   ftest = fakeopen("data\\pictures.dir",fname,"rb");
   if (ftest == NULL)
   {
      app->stateChange();
   }
   else
   {
      fclose(ftest);
      surfaceManager->remove(background);
      background = surfaceManager->load(fname+5,"data\\pictures.dir");
   }
}

//-------------------------------------------------------------------------
// cinnost pri zastaveni zobrazovani objektu
//-------------------------------------------------------------------------
void TheEnd::stop()
{
#ifdef CLASSIC_DEBUG
   OutputDebugString("TheEnd::stop()\n");
#endif
   kbd.filter_lastscan = true;
   kbd.lastScanReset();
   kbd.lastASCIIReset();
#ifdef CLASSIC_DEBUG
   OutputDebugString("TheEnd::stop()\n");
#endif
}

//-------------------------------------------------------------------------
// cinnost pri definitivnim ukonceni pouzivani
//-------------------------------------------------------------------------
void TheEnd::unload()
{
}
